DROP TABLE IF EXISTS updates;
DROP TABLE IF EXISTS error;
DROP TABLE IF EXISTS report;

CREATE TABLE changelog (
  id int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  otype VARCHAR(255) NOT NULL ,
  oid VARCHAR(255) NOT NULL ,
  time DATETIME NOT NULL ,
  status ENUM('NEW', 'MODIFIED', 'DELETED') NOT NULL,
  UNIQUE KEY (otype,oid,time,status)
) ENGINE=INNODB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE report (
  id int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  time datetime NOT NULL UNIQUE KEY
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE report_error (
  id int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  oid varchar(255) CHARACTER SET utf8 NOT NULL,
  field enum('BILL_SUMMARY','BILL_TITLE','BILL_ACTION','BILL_SPONSOR','BILL_COSPONSOR','BILL_TEXT_PAGE') CHARACTER SET utf8 NOT NULL,
  openedAt datetime NOT NULL KEY,
  closedAt datetime DEFAULT NULL KEY
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `report_observation` (
  id int(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  reportId int(11) DEFAULT NULL,
  errorId int(11) DEFAULT NULL,
  oid varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  field enum('BILL_SUMMARY','BILL_TITLE','BILL_ACTION','BILL_SPONSOR','BILL_COSPONSOR','BILL_TEXT_PAGE') COLLATE utf8_unicode_ci NOT NULL,
  actualValue text COLLATE utf8_unicode_ci,
  observedValue text COLLATE utf8_unicode_ci,
  FOREIGN KEY (reportId) REFERENCES report (id),
  FOREIGN KEY (errorId) REFERENCES report_error (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci

